; ======================================================
;  Fellow Amiga Emulator      
;  Translation of Amiga graphics data to temporary format
;  suitable for fast drawing on a chunky display.
;  (C) 1993-1998 Petter Schau 
; ======================================================


        .586p
DGROUP group _DATA,_BSS
_TEXT  segment para public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

public graphemstart_
graphemstart_:                          ; Used to check code alignment
startlbl:

include defs.inc
include mac\plan2c.mac


#ifdef USE_NEW_SPRITE
	
                        ALIGN32


;----------------------------------
; Decode sprite 4 colors
; edx (old esi) - buffer to decode to
; eax (old ecx) - pointer to spritedata array
; ebx - sprite class (0,1,2,3)
;----------------------------------

public nspriteP2C4ASM_
nspriteP2C4ASM_:	pushad
			mov	esi, edx
			mov	ecx, eax
			xor     edx,edx
			mov	edi,dword ptr [_sprite4_0 + ebx*4]
			mov	ebp,dword ptr [_sprite4_1 + ebx*4]
        		mov     dl,byte ptr [ecx]
        		mov     eax,dword ptr [8*edx + edi]
        		mov     ebx,dword ptr [8*edx + edi + 4]
        		mov     dl,byte ptr 2[ecx]
        		or      eax,dword ptr [8*edx + ebp]
        		or      ebx,dword ptr [8*edx + ebp + 4]
        		mov     dl,byte ptr 1[ecx]
        		mov     dword ptr [esi],eax
        		mov     dword ptr 4[esi],ebx
        		mov     eax,dword ptr [8*edx + edi]
        		mov     ebx,dword ptr [8*edx + edi + 4]
        		mov     dl,byte ptr 3[ecx]
        		or      eax,dword ptr [8*edx + ebp]
        		or	ebx,dword ptr [8*edx + ebp + 4]
        		mov     dword ptr 8[esi],eax
        		mov     dword ptr 12[esi],ebx
			popad
			ret


                	ALIGN32


;----------------------------------------------------------
; Decode sprite 16 colors
; ebx (old esi)  - buffer to decode to
; eax (old ecx)  - pointer to spritedata array even sprite
; edx (old none) - pointer to spritedata array odd sprite
;----------------------------------------------------------

public nspriteP2C16ASM_
nspriteP2C16ASM_:	pushad
			mov	esi, ebx
			mov	ecx, eax
			push	edx
			xor     edx,edx
        		mov     dl,byte ptr [ecx]
        		mov     eax,dword ptr [_decosc01  +8*edx]
        		mov     ebx,dword ptr [_decosc01+4+8*edx]
        		mov     dl,byte ptr 1[ecx]
        		mov     edi,dword ptr [_decosc01  +8*edx]
        		mov     ebp,dword ptr [_decosc01+4+8*edx]
        		mov     dl,byte ptr 2[ecx]
        		or      eax,dword ptr [_decosc02  +8*edx]
        		or      ebx,dword ptr [_decosc02+4+8*edx]
        		mov     dl,byte ptr 3[ecx]
        		or      edi,dword ptr [_decosc02  +8*edx]
        		or      ebp,dword ptr [_decosc02+4+8*edx]
			pop	ecx
	       		mov     dl,byte ptr [ecx]
        		or      eax,dword ptr [_decosc03  +8*edx]
        		or      ebx,dword ptr [_decosc03+4+8*edx]
        		mov     dl,byte ptr [ecx]
        		or      edi,dword ptr [_decosc03  +8*edx]
        		or     ebp,dword ptr [_decosc03+4+8*edx]
        		mov     dl,byte ptr [ecx]
        		or      eax,dword ptr [_decosc04  +8*edx]
        		or      ebx,dword ptr [_decosc04+4+8*edx]
        		mov     dl,byte ptr [ecx]
        		or      edi,dword ptr [_decosc04  +8*edx]
        		or      ebp,dword ptr [_decosc04+4+8*edx]
        		mov     dword ptr [esi],eax
        		mov     dword ptr 4[esi],ebx
        		mov     dword ptr 8[esi],edi
        		mov     dword ptr 12[esi],ebp
			popad
        		ret

#endif
	
                        ALIGN32


;----------------------------------
; Decode sprite 4 colors
; esi - buffer to decode to
; ecx - pointer to spritedata array
; ebx - sprite class (0,1,2,3)
;----------------------------------

decode4sprite_:		xor     edx,edx
			mov	edi,dword ptr [_sprite4_0 + ebx*4]
			mov	ebp,dword ptr [_sprite4_1 + ebx*4]
        		mov     dl,byte ptr [ecx]
        		mov     eax,dword ptr [8*edx + edi]
        		mov     ebx,dword ptr [8*edx + edi + 4]
        		mov     dl,byte ptr 2[ecx]
        		or      eax,dword ptr [8*edx + ebp]
        		or      ebx,dword ptr [8*edx + ebp + 4]
        		mov     dl,byte ptr 1[ecx]
        		mov     dword ptr [esi],eax
        		mov     dword ptr 4[esi],ebx
        		mov     eax,dword ptr [8*edx + edi]
        		mov     ebx,dword ptr [8*edx + edi + 4]
        		mov     dl,byte ptr 3[ecx]
        		or      eax,dword ptr [8*edx + ebp]
        		or     ebx,dword ptr [8*edx + ebp + 4]
        		mov     dword ptr 8[esi],eax
        		mov     dword ptr 12[esi],ebx
			ret


                	ALIGN32


;----------------------------------
; Decode sprite 16 colors
; esi - buffer to decode to
; ecx - pointer to spritedata array
;----------------------------------

decode16sprite_:	xor     edx,edx
        		mov     dl,byte ptr [ecx]
        		mov     eax,dword ptr [_decosc01  +8*edx]
        		mov     ebx,dword ptr [_decosc01+4+8*edx]
        		mov     dl,byte ptr 1[ecx]
        		mov     edi,dword ptr [_decosc01  +8*edx]
        		mov     ebp,dword ptr [_decosc01+4+8*edx]
        		mov     dl,byte ptr 2[ecx]
        		or      eax,dword ptr [_decosc02  +8*edx]
        		or      ebx,dword ptr [_decosc02+4+8*edx]
        		mov     dl,byte ptr 3[ecx]
        		or      edi,dword ptr [_decosc02  +8*edx]
        		or      ebp,dword ptr [_decosc02+4+8*edx]
        		mov     dl,byte ptr 4[ecx]
        		or      eax,dword ptr [_decosc03  +8*edx]
        		or      ebx,dword ptr [_decosc03+4+8*edx]
        		mov     dl,byte ptr 5[ecx]
        		or      edi,dword ptr [_decosc03  +8*edx]
        		or     ebp,dword ptr [_decosc03+4+8*edx]
        		mov     dl,byte ptr 6[ecx]
        		or      eax,dword ptr [_decosc04  +8*edx]
        		or      ebx,dword ptr [_decosc04+4+8*edx]
        		mov     dl,byte ptr 7[ecx]
        		or      edi,dword ptr [_decosc04  +8*edx]
        		or      ebp,dword ptr [_decosc04+4+8*edx]
        		mov     dword ptr [esi],eax
        		mov     dword ptr 4[esi],ebx
        		mov     dword ptr 8[esi],edi
        		mov     dword ptr 12[esi],ebp
        		ret



; Decode sprites

; We know dma is on, so read all the needed datawords
; if spritestate is 0, read two control words
; else if spritestate is 1, we are waiting for first line
; else if spritestate is 2 , read two data words and decode them
; else if spritestate is 3, sprite is off
; state 4 is when data is written directly to the data registers
;         and real state is 2
; state 5 is when sprite is really off, but data is written.

                        ALIGN32

public decodesprites_
decodesprites_:
		push	esi		; Esi used in nxt_inst loop copper part
		push	eax
		xor	esi, esi	; Counts sprites*4
		; No sprites initially

		mov	dword ptr [_spritesonline], 0
	
dsloop:		mov	ebx, dword ptr [_spritestate + esi]; state for sprite
		mov	dword ptr [_spriteonline + esi], 0; Not displayed
		mov	dword ptr [_sprite16col + esi],0; Initially 4 color
		cmp	ebx, 3
		je	dsloopend	; State 3, skip sprite, this is OK
		cmp	ebx, 1
		jne	dsrwr0

; State 1, waiting for first line, check if this line is the one

		mov	eax, dword ptr [_ypos]; Next line the first line?
		cmp	eax, dword ptr [_spry + esi]
		jne	dsloopend	; No, skip statechange and sprite
		mov	dword ptr [_spritestate + esi], 2	; Statechange
		mov	ebx, 2
dsrwr0:		; State 2 or 0 or 4 or 5, Here two words must be read
		mov	ecx, dword ptr [_sprpt + esi]
		cmp	ebx, 4  ; State 4, words replaced by CPU
		je	dsrwr0a
		cmp	ebx, 5	; State 5, words written out of order by CPU
		je	dsrwr0b
		mov	edx, dword ptr [_cmem + ecx]
		mov	dword ptr [_sprdat + esi], edx
dsrwr0a:	add	ecx, 4
		and	ecx, 01ffffeh
		mov	dword ptr [_sprpt + esi], ecx
		test	ebx, ebx
		jz	dsrwc0
		mov	ecx, dword ptr [_sprly + esi]
		cmp	ecx, dword ptr [_ypos]
		je	dsrwc0

		; State 2, Data words
		; If sprite is attached, and the other too, let odd sprite
		; do the decoding

dsrwr0b:	test	esi, 04h	; test wether we are odd or even sprite
        jnz     dsoddsprite
        test    dword ptr _spratt+4[esi],1 ; Even sprite is attached if
        jz      dsrwrr                     ; odd sprite is attached
        ; OK we are attached and even, let odd sprite do the job
        jmp     dsresumeattached
dsoddsprite:
; We are odd sprite, if attached, both are.

        test    dword ptr _spratt[esi],1 ; Attached?
        jz      dsrwrr

        ; OK we are attached and odd, we must do the job

        lea     ecx,[_sprdat-4+esi]
        push    esi
        lea     esi,[_sprite+4*esi]
        call    decode16sprite_
        pop     esi
        mov     dword ptr _spritesonline,1
        mov     dword ptr _spriteonline[esi],1
        mov     dword ptr _sprite16col[esi],1
        jmp     dsresumeattached

dsrwrr:  ; No attached sprites, 4 color decode
        lea     ecx,[_sprdat+esi]
        mov     ebx,esi
        shr     ebx,3
        push    esi
        lea     esi,[_sprite+4*esi]

        call    decode4sprite_
        pop     esi
        mov     dword ptr _spritesonline,1
        mov     dword ptr _spriteonline[esi],1
dsresumeattached:
        cmp     dword ptr _spritestate[esi],4
        jb      drest
        mov	eax, dword ptr [_spritestateold + esi]
	mov     dword ptr _spritestate[esi], eax
drest:	cmp	dword ptr [_spritestate + esi], 5	
	je	dres1
        mov     eax,dword ptr _ypos    ; Check if this was the last line
        inc     eax
        cmp     eax,dword ptr _sprly[esi]
        jne     dsloopend
        mov     dword ptr _spritestate[esi],0
        jmp     dsloopend
dres1:  mov     dword ptr _spritestate[esi],3
        jmp     dsloopend
dsrwc0: ; State 0, Control words
        test    edx,edx
        jnz     dsrwcc
        mov     dword ptr _spritestate[esi],3
        mov     dword ptr _sprx[esi],edx
        mov     dword ptr _spry[esi],edx
        mov     dword ptr _sprly[esi],edx
        mov     dword ptr _spratt[esi],edx
        jmp     dsloopend
dsrwcc:
        mov     eax,edx
        rol     eax,1
        and     eax,1
        mov     dword ptr _spratt[esi],eax
        xor     eax,eax                 ; Find x position
        mov     al,dh
        shl     eax,1
        mov     ebx,edx
        shr     ebx,24
        and     ebx,1
        or      eax,ebx
        inc     eax                     ; Sprites delayed 1 cycle
        mov     dword ptr _sprx[esi],eax  ; Now found x position
        xor     eax,eax                 ; Find first y position
        mov     al,dl
        mov     ebx,edx
        shr     ebx,16
        and     ebx,0400h
        shr     ebx,2
        or      eax,ebx
        mov     dword ptr _spry[esi],eax   ; Now found first y position
        xor     eax,eax                 ; Now find last y position
        ror     edx,16
        mov     al,dl
        mov     ah,dh
        and     eax,02ffh
        shr     ah,1
        mov     dword ptr _sprly[esi],eax   ; Now found last y position
        cmp     eax,dword ptr [_ypos]
        je      dsloopend
        mov     dword ptr _spritestate[esi],1  ; Set waiting for first line
dsloopend:
        add     esi,4
        cmp     esi,dword ptr [_spriteddfkill]
        jae     dsexit
        cmp     esi,32
        jne     dsloop
dsexit:
        pop     eax
        pop     esi
        ret


                        ALIGN32

public mergesprites
mergesprites:
        xor     esi,esi
	mov	dword ptr [_spritesonline],0
	
; The big question is, should PF1 or PF2 be the right one to use
; Abacus suggestes PF1 in non-dual mode. That fails. So use PF2

        test    dword ptr _bplcon0,00400h
        jnz     mergedualsprites
        mov     ecx,dword ptr _bplcon2
        and     ecx,38h
        test    dword ptr _bplcon0,08000h
        jz       mergeloresloop
        cmp     byte ptr [_config_graphics_mode],0
        je      mergehiresnewsprites
        cmp     byte ptr [_config_graphics_mode],3
        je      mergehiresnewsprites
        cmp     byte ptr [_config_graphics_mode],4
        je      mergehiresnewsprites
        cmp     byte ptr [_config_graphics_mode],5
        je      mergehiresnewsprites

mergehires320loop:
        test    dword ptr _spriteonline[esi],1
        jz      mergehires320skipsprite
        mov     edi,dword ptr _sprx[esi]
        mov     eax,dword ptr _DIWlastvisiblepos
        shr     eax,1
        cmp     edi,eax        ;  dword ptr _DIWlastvisiblepos
        ja      mergehires320skipsprite
        lea     ebp,[_sprite+4*esi]

; determine whether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front
        xor     eax,eax
        cmp     ecx,esi
        jbe     mergehires320setuploop
        mov     eax,010000h
mergehires320setuploop:
        push    ecx
        push    esi
        lea     esi,[_spritetranslate+eax]
        xor     eax,eax
        xor     ebx,ebx
mergehires320loop2:
        mov     edx,dword ptr [ebp]             ; 1 Pixel 0-3
        mov     ecx,dword ptr [_linje+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+edi],ecx      ; 12 (13) (reg dep)

        mov     edx,dword ptr 4[ebp]            ; 1 Pixel 4-7
        mov     ecx,dword ptr [_linje+4+edi]    ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+4+edi],ecx    ; (12) 13 (reg dep)

        mov     edx,dword ptr 8[ebp]            ; 1 Pixel 8-11
        mov     ecx,dword ptr [_linje+8+edi]    ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+8+edi],ecx    ; 12 (13) (reg dep)

        mov     edx,dword ptr 12[ebp]           ; 1 Pixel 12-15
        mov     ecx,dword ptr [_linje+12+edi]   ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+12+edi],ecx   ; 12 (13) (reg dep)

        pop     esi
        pop     ecx

mergehires320skipsprite:
        add     esi,4
        cmp	esi,32
	jne     mergehires320loop
        ret




                        ALIGN32

mergeloresloop:
        test    dword ptr _spriteonline[esi],1
        jz      mergeloresskipsprite
        mov     edi,dword ptr _sprx[esi]
        cmp     edi,dword ptr _DIWlastvisiblepos
        ja      mergeloresskipsprite
        lea     ebp,[_sprite+4*esi]

; determine whether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front
        xor     eax,eax
        cmp     ecx,esi
        jbe     mergeloressetuploop
        mov     eax,010000h
mergeloressetuploop:
        push    ecx
        push    esi
        lea     esi,[_spritetranslate+eax]
        xor     eax,eax
        xor     ebx,ebx
mergeloresloop2:
        mov     edx,dword ptr [ebp]             ; 1 Pixel 0-3
        mov     ecx,dword ptr [_linje+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+edi],ecx      ; 12 (13) (reg dep)

        mov     edx,dword ptr 4[ebp]            ; 1 Pixel 4-7
        mov     ecx,dword ptr [_linje+4+edi]    ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+4+edi],ecx    ; (12) 13 (reg dep)

        mov     edx,dword ptr 8[ebp]            ; 1 Pixel 8-11
        mov     ecx,dword ptr [_linje+8+edi]    ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+8+edi],ecx    ; 12 (13) (reg dep)

        mov     edx,dword ptr 12[ebp]           ; 1 Pixel 12-15
        mov     ecx,dword ptr [_linje+12+edi]   ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+12+edi],ecx   ; 12 (13) (reg dep)

        pop     esi
        pop     ecx

mergeloresskipsprite:
        add     esi,4
        cmp	esi,32
	jne     mergeloresloop
        ret


                        ALIGN32

mergehiresnewsprites:
mergehiresnewloop:
        test    dword ptr _spriteonline[esi],1
        jz      mergehiresnewskipsprite
        mov     edi,dword ptr _sprx[esi]
        add     edi,edi
        cmp     edi,dword ptr _DIWlastvisiblepos
        ja      mergehiresnewskipsprite
        lea     ebp,[_sprite+4*esi]

; determine whether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front

        xor     eax,eax
        cmp     ecx,esi
        jbe     mergehiresnewsetuploop
        mov     eax,010000h
mergehiresnewsetuploop:
        push    ecx
        push    esi
        lea     esi,[_spritetranslate+eax]
        xor     eax,eax
        xor     ebx,ebx
mergehiresnewloop2:
        mov     edx,dword ptr [ebp]             ; 1 Pixel 0-1
        mov     ecx,dword ptr [_linje+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dl                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16
        mov     al,dh                           ; Pixel 2-3
        mov     bl,dh
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16                          ; 12 
        ror     edx,16
        mov     dword ptr [_linje+edi],ecx      ; 12 (13) (reg dep)
        mov     ecx,dword ptr [_linje+4+edi]    ; 1
        mov     bl,dl                           ; 5
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     bl,dh                           ; 5
        mov     al,dh                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+4+edi],ecx      ; 12 (13) (reg dep)


        mov     edx,dword ptr 4[ebp]             ; 1 Pixel 4-5
        mov     ecx,dword ptr [_linje+8+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dl                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16
        mov     al,dh                           ; Pixel 6-7
        mov     bl,dh
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16                          ; 12 
        ror     edx,16
        mov     dword ptr [_linje+8+edi],ecx      ; 12 (13) (reg dep)
        mov     ecx,dword ptr [_linje+12+edi]    ; 1
        mov     bl,dl                           ; 5
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     bl,dh                           ; 5
        mov     al,dh                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+12+edi],ecx      ; 12 (13) (reg dep)


        mov     edx,dword ptr 8[ebp]             ; 1 Pixel 8-9
        mov     ecx,dword ptr [_linje+16+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dl                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16
        mov     al,dh                           ; Pixel 10-11
        mov     bl,dh
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16                          ; 12 
        ror     edx,16
        mov     dword ptr [_linje+16+edi],ecx      ; 12 (13) (reg dep)
        mov     ecx,dword ptr [_linje+20+edi]    ; 1
        mov     bl,dl                           ; 5
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     bl,dh                           ; 5
        mov     al,dh                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+20+edi],ecx      ; 12 (13) (reg dep)


        mov     edx,dword ptr 12[ebp]             ; 1 Pixel 12-13
        mov     ecx,dword ptr [_linje+24+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dl                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16
        mov     al,dh                           ; Pixel 14-15
        mov     bl,dh
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16                          ; 12 
        ror     edx,16
        mov     dword ptr [_linje+24+edi],ecx      ; 12 (13) (reg dep)
        mov     ecx,dword ptr [_linje+28+edi]    ; 1
        mov     bl,dl                           ; 5
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     bl,dh                           ; 5
        mov     al,dh                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+28+edi],ecx      ; 12 (13) (reg dep)

        pop     esi
        pop     ecx

mergehiresnewskipsprite:
        add     esi,4
        cmp	esi,32
	jne     mergehiresnewloop
        ret


                        ALIGN32

mergehiressprites:
mergehiresloop:
        test    dword ptr _spriteonline[esi],1
        jz      mergehiresloopend
        mov     edi,dword ptr _sprx[esi]
        add     edi,edi
        cmp     edi,dword ptr _DIWlastvisiblepos
        ja      mergehiresloopend
        lea     eax,[_sprite+4*esi]
        xor     ebp,ebp
; Is this a 16 color sprite??
        test    dword ptr _sprite16col[esi],1
        jz      mergehiresno16
mergehiresno16:

; determine wether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front
        push    ecx
        cmp     ecx,esi
        ja      mergehiresloopinfront2
mergehiresloopbehind2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje+edi+2*ebp]
        test    cl,cl
        jnz     mhhb1
        test    dl,dl
        jz      mhhb1
        mov     cl,dl
        add     cl,bl
mhhb1:
        test    ch,ch
        jnz     mhhb2
        test    dl,dl
        jz      mhhb2
        mov     ch,dl
        add     ch,bl
mhhb2:
        ror     ecx,16
        test    cl,cl
        jnz     mhhb3
        test    dh,dh
        jz      mhhb3
        mov     cl,dh
        add     cl,bl
mhhb3:
        test    ch,ch
        jnz     mhhb4
        test    dh,dh
        jz      mhhb4
        mov     ch,dh
        add     ch,bl
mhhb4:
        ror     ecx,16
        mov     dword ptr [_linje+edi+2*ebp],ecx
        add     ebp,2
        cmp     ebp,16
        jne     mergehiresloopbehind2
        pop     ecx
        jmp     mergehiresloopend

mergehiresloopinfront2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje+edi+2*ebp]
        test    dl,dl
        jz      mhh1
        mov     cl,dl
        add     cl,bl
mhh1:
        test    dl,dl
        jz      mhh2
        mov     ch,dl
        add     ch,bl
mhh2:
        ror     ecx,16
        test    dh,dh
        jz      mhh3
        mov     cl,dh
        add     cl,bl
mhh3:
        test    dh,dh
        jz      mhh4
        mov     ch,dh
        add     ch,bl
mhh4:
        ror     ecx,16
        mov     dword ptr [_linje+edi+2*ebp],ecx
        add     ebp,2
        cmp     ebp,16
        jne     mergehiresloopinfront2
        pop     ecx
mergehiresloopend:
        add     esi,4
        cmp	esi,32
	jne     mergehiresloop
        ret


                        ALIGN32

mergedualsprites:
        
mergedualloresloop:
        test    dword ptr _spriteonline[esi],1
        jz      mergedualloresloopend
        mov     edi,dword ptr _sprx[esi]
        cmp     edi,dword ptr _DIWlastvisiblepos
        ja      mergedualloresloopend
        lea     eax,[_sprite+4*esi]
        xor     ebp,ebp



; Merge with PF1
; determine whether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front

; test, sprite in front of PF1? Draw it there
;       sprite in front of PF2? Draw it there
;       else draw it behind PF2
mergedualloresPF1:
        mov     ecx,dword ptr _bplcon2
        test    ecx,040h
        jnz     mergedualloresevenpri
        and     ecx,7h
        shl     ecx,3
        cmp     ecx,esi
        ja      mergedualloresPF1loopinfront2
        mov     ecx,dword ptr _bplcon2
        and     ecx,038h
        cmp     ecx,esi
        ja      mergedualloresPF2loopinfront2
        jmp     mergedualloresPF2loopbehind2
mergedualloresevenpri:
        and     ecx,38h
        cmp     ecx,esi
        ja      mergedualloresPF2loopinfront2
        mov     ecx,dword ptr _bplcon2
        and     ecx,07h
        shl     ecx,3
        cmp     ecx,esi
        ja      mergedualloresPF1loopinfront2

mergedualloresPF1loopbehind2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje+edi+ebp]
        test    cl,cl
        jnz     mdlb1
        test    dl,dl
        jz      mdlb1
        mov     cl,dl
mdlb1:
        test    ch,ch
        jnz     mdlb2
        test    dh,dh
        jz      mdlb2
        mov     ch,dh
mdlb2:
        ror     edx,16
        ror     ecx,16
        test    cl,cl
        jnz     mdlb3
        test    dl,dl
        jz      mdlb3
        mov     cl,dl
mdlb3:
        test    ch,ch
        jnz     mdlb4
        test    dh,dh
        jz      mdlb4
        mov     ch,dh
mdlb4:
        ror     ecx,16
        mov     dword ptr [_linje+edi+ebp],ecx
        add     ebp,4
        cmp     ebp,16
        jne     mergedualloresPF1loopbehind2
        jmp     mergedualloresloopend

                ALIGN32

mergedualloresPF1loopinfront2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje+edi+ebp]
        test    dl,dl
        jz      mdl1
        mov     cl,dl
mdl1:
        test    dh,dh
        jz      mdl2
        mov     ch,dh
mdl2:
        ror     edx,16
        ror     ecx,16
        test    dl,dl
        jz      mdl3
        mov     cl,dl
mdl3:
        test    dh,dh
        jz      mdl4
        mov     ch,dh
mdl4:
        ror     ecx,16
        mov     dword ptr [_linje+edi+ebp],ecx
        add     ebp,4
        cmp     ebp,16
        jne     mergedualloresPF1loopinfront2
        jmp     mergedualloresloopend

                        ALIGN32

mergedualloresPF2loopbehind2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje2+edi+ebp]
        test    cl,cl
        jnz     mdlpf2b1
        test    dl,dl
        jz      mdlpf2b1
        mov     cl,dl
mdlpf2b1:
        test    ch,ch
        jnz     mdlpf2b2
        test    dh,dh
        jz      mdlpf2b2
        mov     ch,dh
mdlpf2b2:
        ror     edx,16
        ror     ecx,16
        test    cl,cl
        jnz     mdlpf2b3
        test    dl,dl
        jz      mdlpf2b3
        mov     cl,dl
mdlpf2b3:
        test    ch,ch
        jnz     mdlpf2b4
        test    dh,dh
        jz      mdlpf2b4
        mov     ch,dh
mdlpf2b4:
        ror     ecx,16
        mov     dword ptr [_linje2+edi+ebp],ecx
        add     ebp,4
        cmp     ebp,16
        jne     mergedualloresPF2loopbehind2

        jmp     mergedualloresloopend

                ALIGN32

mergedualloresPF2loopinfront2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje2+edi+ebp]
        test    dl,dl
        jz      mdlpf21
        mov     cl,dl
mdlpf21:
        test    dh,dh
        jz      mdlpf22
        mov     ch,dh
mdlpf22:
        ror     edx,16
        ror     ecx,16
        test    dl,dl
        jz      mdlpf23
        mov     cl,dl
mdlpf23:
        test    dh,dh
        jz      mdlpf24
        mov     ch,dh
mdlpf24:
        ror     ecx,16
        mov     dword ptr [_linje2+edi+ebp],ecx
        add     ebp,4
        cmp     ebp,16
        jne     mergedualloresPF2loopinfront2
mergedualloresloopend:
skipdualloressprite:
        add     esi,4
        cmp	esi,32
	jne     mergedualloresloop
        ret

; Drawing sprites in HAM mode is tricky since we can't modify
; the "line" arrays, it will screw up the HAM encoded color data.
; So the current highly inefficient method is to draw the HAM line
; to the framebuffer first, and then have another pass of drawing,
; this time the sprites.
; But framebuffer memory is so slow...
; I don't think there is much to do about it.
; I guess the guy who invented HAM felt pretty clever.

; In:	 edx - pointer to first pixel in this line in framebuffer

; Mode of operation:
; 1. Sprite number * 4 is in esi
; 2. Skip sprite if it is not shown on this line.
; 3. Skip sprite is it starts after the end of DIW.
; 4. Get pointer to 16 bytes of sprite data in edi
; 5. Set up index into the spritedecision table depending on the sprites
;    position (in front or in back of playfield.)
; 6. Calculate pointer to first pixel in the sprite in the framebuffer.
;    pointer = edx + sprx - clipleftx
;    One danger is that this is before the line starts.
;    So we must check for that, too.
; 7. Draw sprite
; 8. Loop to 2
; 
; First Try...
; 

; Hires framebuffer, 16-bit pixels

		ALIGN32
	
public mergesprites_ham_hiw_
mergesprites_ham_hiw_:
		push	edx
		test	byte ptr [_spritesonline],1
		jz	mhamhiw_exit
		mov	esi,0
		mov	dword ptr [_spritesonline],0
mhamhiw_loop:	test	byte ptr [_spriteonline + esi],1
		jz	mhamhiw_skip
		mov     edi,dword ptr [_sprx + esi]
		cmp	edi,dword ptr [_DIWlastvisiblepos]
		ja	mhamhiw_skip
		lea	ebp,[_sprite + 4*esi]
		pop	edx
		push	edx
		lea	edx,[edx + 4*edi]
		mov	eax,dword ptr [_DIWfirstvisiblepos]
		mov	ebx,0
		cmp	edi,eax
		jae	mhamhiw_full
		mov	ebx,eax
		sub	ebx,edi
		cmp	ebx,16
		jae	mhamhiw_skip
		lea	edx,[edx + 4*ebx]
		add	ebp,ebx
mhamhiw_full:	neg	eax
		lea	edx,[edx + 4*eax]
		cmp	ecx,esi
		jbe	mhamhiw_behind
		push	ecx		; Sprites in front of playfield 
		push	esi
		mov	eax,0
		mov	ecx,ebx
mhamhiw_loop2:	mov	al,byte ptr [ebp]
		test	al,al
		jz	mhamhiw_trans
		mov	ebx,dword ptr [_shadcol + eax]
		mov	dword ptr [edx],ebx
mhamhiw_trans:	add	edx,4
		inc	ebp
		inc	ecx
		cmp	ecx,16
		jb	mhamhiw_loop2			
		pop	esi
		pop	ecx
mhamhiw_skip:	add	esi,4
		cmp	esi,32
		jne	mhamhiw_loop
mhamhiw_exit:	pop	edx
		ret

mhamhiw_behind:	push	ecx		; Sprites behind playfield
		push	esi
		mov	eax,0
		mov	ecx,ebx
mhamhiw_bloop:	test	byte ptr [_linje + edx + ecx],0
		jnz	mhamhiw_btrans
		mov	al,byte ptr [ebp]
		test	al,al
		jz	mhamhiw_btrans
		mov	ebx,dword ptr [_shadcol + eax]
		mov	dword ptr [edx],ebx
mhamhiw_btrans:	add	edx,4
		inc	ebp
		inc	ecx
		cmp	ecx,16
		jb	mhamhiw_bloop
		pop	esi
		pop	ecx
mhamhiw_bskip:	add	esi,4
		cmp	esi,32
		jne	mhamhiw_loop
mhamhiw_bexit:	pop	edx
		ret

	
			
; Lores framebuffer, 16-bit pixels

		ALIGN32
	
public mergesprites_ham_low_
mergesprites_ham_low_:
		push	edx
		test	byte ptr [_spritesonline],1
		jz	mhamlow_exit
		mov	esi,0
		mov	dword ptr [_spritesonline],0
mhamlow_loop:	test	byte ptr [_spriteonline + esi],1
		jz	mhamlow_skip
		mov     edi,dword ptr [_sprx + esi]
		cmp	edi,dword ptr [_DIWlastvisiblepos]
		ja	mhamlow_skip
		lea	ebp,[_sprite + 4*esi]
		pop	edx
		push	edx
		lea	edx,[edx + 2*edi]
		mov	eax,dword ptr [_DIWfirstvisiblepos]
		mov	ebx,0
		cmp	edi,eax
		jae	mhamlow_full
		mov	ebx,eax
		sub	ebx,edi
		cmp	ebx,16
		jae	mhamlow_skip
		lea	edx,[edx + 2*ebx]
		add	ebp,ebx
mhamlow_full:	neg	eax
		lea	edx,[edx + 2*eax]
		cmp	ecx,esi
		jbe	mhamlow_behind
		push	ecx		; Sprites in front of playfield 
		push	esi
		mov	eax,0
		mov	ecx,ebx
mhamlow_loop2:	mov	al,byte ptr [ebp]
		test	al,al
		jz	mhamlow_trans
		mov	ebx,dword ptr [_shadcol + eax]
		mov	word ptr [edx],bx
mhamlow_trans:	add	edx,2
		inc	ebp
		inc	ecx
		cmp	ecx,16
		jb	mhamlow_loop2			
		pop	esi
		pop	ecx
mhamlow_skip:	add	esi,4
		cmp	esi,32
		jne	mhamlow_loop
mhamlow_exit:	pop	edx
		ret

mhamlow_behind:	push	ecx		; Sprites behind playfield
		push	esi
		mov	eax,0
		mov	ecx,ebx
mhamlow_bloop:	test	byte ptr [_linje + edx + ecx],0
		jnz	mhamlow_btrans
		mov	al,byte ptr [ebp]
		test	al,al
		jz	mhamlow_btrans
		mov	ebx,dword ptr [_shadcol + eax]
		mov	word ptr [edx],bx
mhamlow_btrans:	add	edx,2
		inc	ebp
		inc	ecx
		cmp	ecx,16
		jb	mhamlow_bloop
		pop	esi
		pop	ecx
mhamlow_bskip:	add	esi,4
		cmp	esi,32
		jne	mhamlow_loop
mhamlow_bexit:	pop	edx
		ret


; Lores framebuffer, 8-bit pixels

		ALIGN32
	
public mergesprites_ham_lob_
mergesprites_ham_lob_:
		push	edx
		test	byte ptr [_spritesonline],1
		jz	mhamlob_exit
		mov	esi,0
		mov	dword ptr [_spritesonline],0
mhamlob_loop:	test	byte ptr [_spriteonline + esi],1
		jz	mhamlob_skip
		mov     edi,dword ptr [_sprx + esi]
		cmp	edi,dword ptr [_DIWlastvisiblepos]
		ja	mhamlob_skip
		lea	ebp,[_sprite + 4*esi]
		pop	edx
		push	edx
		add	edx,edi
		mov	eax,dword ptr [_DIWfirstvisiblepos]
		mov	ebx,0
		cmp	edi,eax
		jae	mhamlob_full
		mov	ebx,eax
		sub	ebx,edi
		cmp	ebx,16
		jae	mhamlob_skip
		add	edx,ebx
		add	ebp,ebx
mhamlob_full:	neg	eax
		add	edx,eax
		cmp	ecx,esi
		jbe	mhamlob_behind
		push	ecx		; Sprites in front of playfield 
		push	esi
		mov	eax,0
		mov	ecx,ebx
mhamlob_loop2:	mov	al,byte ptr [ebp]
		test	al,al
		jz	mhamlob_trans
		mov	ebx,dword ptr [_shadcol + eax]
		mov	byte ptr [edx],bl
mhamlob_trans:	inc	edx
		inc	ebp
		inc	ecx
		cmp	ecx,16
		jb	mhamlob_loop2			
		pop	esi
		pop	ecx
mhamlob_skip:	add	esi,4
		cmp	esi,32
		jne	mhamlob_loop
mhamlob_exit:	pop	edx
		ret

mhamlob_behind:	push	ecx		; Sprites behind playfield
		push	esi
		mov	eax,0
		mov	ecx,ebx
mhamlob_bloop:	test	byte ptr [_linje + edx + ecx],0
		jnz	mhamlob_btrans
		mov	al,byte ptr [ebp]
		test	al,al
		jz	mhamlob_btrans
		mov	ebx,dword ptr [_shadcol + eax]
		mov	byte ptr [edx],bl
mhamlob_btrans:	inc	edx
		inc	ebp
		inc	ecx
		cmp	ecx,16
		jb	mhamlob_bloop
		pop	esi
		pop	ecx
mhamlob_bskip:	add	esi,4
		cmp	esi,32
		jne	mhamlob_loop
mhamlob_bexit:	pop	edx
		ret

	
			
	
; Planar to chunky conversion
; Is completely replaceable in C
	
#ifndef PLANAR_C
	


CLEAR_EDGES macro ODDSCROLL, EVENSCROLL
local dontswitch, theloop
                mov     ebx,dword ptr [ODDSCROLL]
                mov     edx,dword ptr [EVENSCROLL]
                cmp     edx,ebx
                ja      dontswitch
                mov     edx,ebx
dontswitch:     mov     ebx,dword ptr [_DDFstartpos]
                mov     ebp,dword ptr [_DDFnumberofwords]
                shl     ebp,4
                xor     ecx,ecx
theloop:        mov     dword ptr [_linje + ebx],ecx
                mov     dword ptr [_linje + ebx + ebp],ecx
                add     ebx,4
                sub     edx,4
                jns     theloop
endm

CLEAR_EDGES_DUAL macro ODDSCROLL, EVENSCROLL
local dontswitch, theloop, noclear
                mov     ebx,dword ptr [ODDSCROLL]
                mov     edx,dword ptr [EVENSCROLL]
                cmp     edx,ebx
                ja      dontswitch
                mov     edx,ebx
dontswitch:     mov     ebx,dword ptr [_DDFstartpos]
                mov     ebp,dword ptr [_DDFnumberofwords]
                shl     ebp,4
                xor     ecx,ecx
theloop:        mov     dword ptr [_linje + ebx],ecx
                mov     dword ptr [_linje2 + ebx],ecx
                mov     dword ptr [_linje + ebx + ebp],ecx
                mov     dword ptr [_linje2 + ebx + ebp],ecx
                add     ebx,4
                sub     edx,4
                jns     theloop
noclear:
endm


;----------------------------------------------
; Planar to chunky conversion, 1 bitplane lores
;----------------------------------------------


                        ALIGN32

public decode0_
public decode1_
decode1_:		TEST_HIRES		decodehi1_
                        TEST_MMX                decode1mmx_
                        LOAD_WORDS_TO_DECODE	d1nowork
                        CLEAR_EDGES             _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
d1oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		d1oddloop
			MODULO1
d1nowork:
decode0_:		ret




;--------------------------------------------------
; Planar to chunky conversion, 1 bitplane lores MMX
;--------------------------------------------------


                	ALIGN32

public decode1mmx_
decode1mmx_:            LOAD_WORDS_TO_DECODE    d1mmxnowork
                        CLEAR_EDGES             _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
d1mmxoddloop:           LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d1mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        MODULO1
d1mmxnowork:            ret




;-----------------------------------------------
; Planar to chunky conversion, 2 bitplanes lores
;-----------------------------------------------


                        ALIGN32

public decode2_
decode2_:		TEST_HIRES		decodehi2_
                        TEST_MMX                decode2mmx_
                        LOAD_WORDS_TO_DECODE	d2nowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
			DECIDE_ODDEVEN_EQUAL	d2equal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
d2oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		d2oddloop

			; Decode even planes

                        SETUP_LOOP              _evenscroll, _linje
d2evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco2
			OR_DECODED_DATA
			ITERATE_LOOP		d2evenloop
			MODULO2
d2nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

d2equal:                SETUP_LOOP              _evenscroll, _linje
d2equalloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl2pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		d2equalloop
			MODULO2
			ret




;---------------------------------------------------
; Planar to chunky conversion, 2 bitplanes lores MMX
;---------------------------------------------------


                	ALIGN32

public decode2mmx_
decode2mmx_:            LOAD_WORDS_TO_DECODE    d2mmxnowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
                        DECIDE_ODDEVEN_EQUAL    d2mmxequal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
d2mmxoddloop:           LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d2mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
d2mmxevenloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco2
                        OR_DECODED_DATA_MMX
                        ITERATE_LOOP            d2mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        MODULO2
d2mmxnowork:            ret


        		ALIGN32

			; Decode odd and even planes, scroll equal

d2mmxequal:             SETUP_LOOP_MMX          _evenscroll, _linje
        		LOAD_BITPLANE_PTR       ecx, _bpl1pt
        		LOAD_BITPLANE_PTR       edx, _bpl2pt
d2mmxequalloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		OR_BITPLANE_WORD_MMX    edx, _deco2
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d2mmxequalloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl2pt
                        MODULO2
			ret





;-----------------------------------------------
; Planar to chunky conversion, 3 bitplanes lores
;-----------------------------------------------


                        ALIGN32

public decode3_
decode3_:		TEST_HIRES		decodehi3_
                        TEST_MMX                decode3mmx_
			LOAD_WORDS_TO_DECODE	d3nowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
			DECIDE_ODDEVEN_EQUAL	d3equal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
d3oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			STORE_DECODED_DATA
			ITERATE_LOOP		d3oddloop

			; Decode even planes

                        SETUP_LOOP              _evenscroll, _linje
d3evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco2
			OR_DECODED_DATA
			ITERATE_LOOP		d3evenloop
			MODULO3
d3nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

d3equal:                SETUP_LOOP              _evenscroll, _linje
d3equalloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			STORE_DECODED_DATA
			ITERATE_LOOP		d3equalloop
			MODULO3
			ret




;---------------------------------------------------
; Planar to chunky conversion, 3 bitplanes lores MMX
;---------------------------------------------------


                	ALIGN32

public decode3mmx_
decode3mmx_:            LOAD_WORDS_TO_DECODE    d3mmxnowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
                        DECIDE_ODDEVEN_EQUAL    d3mmxequal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
d3mmxoddloop:           LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco3
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d3mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
d3mmxevenloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco2
                        OR_DECODED_DATA_MMX
                        ITERATE_LOOP            d3mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        MODULO3
d3mmxnowork:            ret


        		ALIGN32

			; Decode odd and even planes, scroll equal

d3mmxequal:             SETUP_LOOP_MMX          _evenscroll, _linje
        		LOAD_BITPLANE_PTR       ecx, _bpl1pt
        		LOAD_BITPLANE_PTR       edx, _bpl2pt
                        LOAD_BITPLANE_PTR       edi, _bpl3pt
d3mmxequalloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    edi, _deco3
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d3mmxequalloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl2pt
                        SAVE_BITPLANE_PTR       edi, _bpl3pt
                        MODULO3
			ret




;-----------------------------------------------
; Planar to chunky conversion, 4 bitplanes lores
;-----------------------------------------------


                        ALIGN32

public decode4_
decode4_:		TEST_HIRES		decodehi4_
                        TEST_MMX                decode4mmx_
                        LOAD_WORDS_TO_DECODE	d4nowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
			DECIDE_ODDEVEN_EQUAL	d4equal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
d4oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			STORE_DECODED_DATA
			ITERATE_LOOP		d4oddloop

			; Decode even planes

                        SETUP_LOOP              _evenscroll, _linje
d4evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl4pt, _deco4
			OR_DECODED_DATA
			ITERATE_LOOP		d4evenloop
			MODULO4
d4nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

d4equal:                SETUP_LOOP              _evenscroll, _linje
d4equalloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			OR_BITPLANE_WORD	_bpl4pt, _deco4
			STORE_DECODED_DATA
			ITERATE_LOOP		d4equalloop
			MODULO4
			ret



;---------------------------------------------------
; Planar to chunky conversion, 4 bitplanes lores MMX
;---------------------------------------------------


                	ALIGN32

public decode4mmx_
decode4mmx_:            LOAD_WORDS_TO_DECODE    d4mmxnowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
                        DECIDE_ODDEVEN_EQUAL    d4mmxequal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
d4mmxoddloop:           LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco3
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d4mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
                        LOAD_BITPLANE_PTR       edx, _bpl4pt
d4mmxevenloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco2
                        OR_BITPLANE_WORD_MMX    edx, _deco4
                        OR_DECODED_DATA_MMX
                        ITERATE_LOOP            d4mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        SAVE_BITPLANE_PTR       edx,_bpl4pt
                        MODULO4
d4mmxnowork:            ret


        		ALIGN32

			; Decode odd and even planes, scroll equal

d4mmxequal:             SETUP_LOOP_MMX          _evenscroll, _linje
        		LOAD_BITPLANE_PTR       ecx, _bpl1pt
        		LOAD_BITPLANE_PTR       edx, _bpl2pt
                        LOAD_BITPLANE_PTR       edi, _bpl3pt
                        LOAD_BITPLANE_PTR       ebp, _bpl4pt
d4mmxequalloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    edi, _deco3
                        OR_BITPLANE_WORD_MMX    ebp, _deco4
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d4mmxequalloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl2pt
                        SAVE_BITPLANE_PTR       edi, _bpl3pt
                        SAVE_BITPLANE_PTR       ebp, _bpl4pt
                        MODULO4
			ret



;-----------------------------------------------
; Planar to chunky conversion, 5 bitplanes lores
;-----------------------------------------------


                        ALIGN32

public decode5_
decode5_:               TEST_MMX                decode5mmx_
                        LOAD_WORDS_TO_DECODE    d5nowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
			DECIDE_ODDEVEN_EQUAL	d5equal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
d5oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			OR_BITPLANE_WORD	_bpl5pt, _deco5
			STORE_DECODED_DATA
			ITERATE_LOOP		d5oddloop

			; Decode even planes

                        SETUP_LOOP              _evenscroll, _linje
d5evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl4pt, _deco4
			OR_DECODED_DATA
			ITERATE_LOOP		d5evenloop
			MODULO5
d5nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

d5equal:                SETUP_LOOP              _evenscroll, _linje
d5equalloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			OR_BITPLANE_WORD	_bpl4pt, _deco4
			OR_BITPLANE_WORD	_bpl5pt, _deco5
			STORE_DECODED_DATA
			ITERATE_LOOP		d5equalloop
			MODULO5
			ret




;---------------------------------------------------
; Planar to chunky conversion, 5 bitplanes lores MMX
;---------------------------------------------------


                	ALIGN32

public decode5mmx_
decode5mmx_:            LOAD_WORDS_TO_DECODE    d5mmxnowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
                        DECIDE_ODDEVEN_EQUAL    d5mmxequal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
                        LOAD_BITPLANE_PTR       ebp, _bpl5pt
d5mmxoddloop:           LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco3
                        OR_BITPLANE_WORD_MMX    ebp, _deco5
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d5mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt
                        SAVE_BITPLANE_PTR       ebp, _bpl5pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
                        LOAD_BITPLANE_PTR       edx, _bpl4pt
d5mmxevenloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco2
                        OR_BITPLANE_WORD_MMX    edx, _deco4
                        OR_DECODED_DATA_MMX
                        ITERATE_LOOP            d5mmxevenloop
                        SAVE_BITPLANE_PTR       ecx, _bpl2pt
                        SAVE_BITPLANE_PTR       edx, _bpl4pt
                        MODULO5
d5mmxnowork:            ret


        		ALIGN32

			; Decode odd and even planes, scroll equal

d5mmxequal:             SETUP_LOOP_MMX          _evenscroll, _linje
        		LOAD_BITPLANE_PTR       ecx, _bpl1pt
        		LOAD_BITPLANE_PTR       edx, _bpl2pt
                        LOAD_BITPLANE_PTR       edi, _bpl3pt
d5mmxequalloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    edi, _deco3
                        LOAD_BITPLANE_PTR       ebp, _bpl4pt
                        OR_BITPLANE_WORD_MMX    ebp, _deco4
                        SAVE_BITPLANE_PTR       ebp, _bpl4pt
                        LOAD_BITPLANE_PTR       ebp, _bpl5pt
                        OR_BITPLANE_WORD_MMX    ebp, _deco5
                        SAVE_BITPLANE_PTR       ebp, _bpl5pt
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d5mmxequalloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl2pt
                        SAVE_BITPLANE_PTR       edi, _bpl3pt
                        MODULO5
			ret



;-----------------------------------------------
; Planar to chunky conversion, 6 bitplanes lores
;-----------------------------------------------


                        ALIGN32

public decode6_
decode6_:               TEST_MMX                decode6mmx_
                        LOAD_WORDS_TO_DECODE    d6nowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
			DECIDE_ODDEVEN_EQUAL	d6equal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
d6oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			OR_BITPLANE_WORD	_bpl5pt, _deco5
			STORE_DECODED_DATA
			ITERATE_LOOP		d6oddloop

			; Decode even planes

                        SETUP_LOOP              _evenscroll, _linje
d6evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl4pt, _deco4
			OR_BITPLANE_WORD	_bpl6pt, _deco6
			OR_DECODED_DATA
			ITERATE_LOOP		d6evenloop
			MODULO6
d6nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

d6equal:                SETUP_LOOP              _evenscroll, _linje
d6equalloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			OR_BITPLANE_WORD	_bpl4pt, _deco4
			OR_BITPLANE_WORD	_bpl5pt, _deco5
			OR_BITPLANE_WORD	_bpl6pt, _deco6
			STORE_DECODED_DATA
			ITERATE_LOOP		d6equalloop
			MODULO6
			ret




;---------------------------------------------------
; Planar to chunky conversion, 6 bitplanes lores MMX
;---------------------------------------------------


                	ALIGN32

public decode6mmx_
decode6mmx_:            LOAD_WORDS_TO_DECODE    d6mmxnowork
                        CLEAR_EDGES             _oddscroll, _evenscroll
                        DECIDE_ODDEVEN_EQUAL    d6mmxequal, _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
                        LOAD_BITPLANE_PTR       ebp, _bpl5pt
d6mmxoddloop:           LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco3
                        OR_BITPLANE_WORD_MMX    ebp, _deco5
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d6mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt
                        SAVE_BITPLANE_PTR       ebp, _bpl5pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
                        LOAD_BITPLANE_PTR       edx, _bpl4pt
                        LOAD_BITPLANE_PTR       edi, _bpl6pt
d6mmxevenloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco2
                        OR_BITPLANE_WORD_MMX    edx, _deco4
                        OR_BITPLANE_WORD_MMX    edi, _deco6
                        OR_DECODED_DATA_MMX
                        ITERATE_LOOP            d6mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        SAVE_BITPLANE_PTR       edx,_bpl4pt
                        SAVE_BITPLANE_PTR       edi,_bpl6pt
                        MODULO6
d6mmxnowork:            ret


        		ALIGN32

			; Decode odd and even planes, scroll equal

d6mmxequal:             SETUP_LOOP_MMX          _evenscroll, _linje
        		LOAD_BITPLANE_PTR       ecx, _bpl1pt
        		LOAD_BITPLANE_PTR       edx, _bpl2pt
                        LOAD_BITPLANE_PTR       edi, _bpl3pt
d6mmxequalloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    edi, _deco3
                        LOAD_BITPLANE_PTR       ebp, _bpl4pt
                        OR_BITPLANE_WORD_MMX    ebp, _deco4
                        SAVE_BITPLANE_PTR       ebp, _bpl4pt
                        LOAD_BITPLANE_PTR       ebp, _bpl5pt
                        OR_BITPLANE_WORD_MMX    ebp, _deco5
                        SAVE_BITPLANE_PTR       ebp, _bpl5pt
                        LOAD_BITPLANE_PTR       ebp, _bpl6pt
                        OR_BITPLANE_WORD_MMX    ebp, _deco6
                        SAVE_BITPLANE_PTR       ebp, _bpl6pt
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            d6mmxequalloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl2pt
                        SAVE_BITPLANE_PTR       edi, _bpl3pt
                        MODULO6
			ret



;----------------------------------------------
; Planar to chunky conversion, 1 bitplane hires
;----------------------------------------------


                        ALIGN32

public decodehi1_
decodehi1_:             TEST_MMX                decodehi1mmx_
                        LOAD_WORDS_TO_DECODE    dh1nowork
                        CLEAR_EDGES             _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP              _oddhiscroll, _linje
dh1oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		dh1oddloop
			MODULO1
dh1nowork:		ret




;--------------------------------------------------
; Planar to chunky conversion, 1 bitplane hires MMX
;--------------------------------------------------


                	ALIGN32

public decodehi1mmx_
decodehi1mmx_:          LOAD_WORDS_TO_DECODE    dh1mmxnowork

                        CLEAR_EDGES             _oddhiscroll, _evenhiscroll

        		; Decode odd planes

                        SETUP_LOOP_MMX          _oddhiscroll, _linje
			LOAD_BITPLANE_PTR	ecx,_bpl1pt
dh1mmxoddloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dh1mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        MODULO1
dh1mmxnowork:           ret



;-----------------------------------------------
; Planar to chunky conversion, 2 bitplanes hires
;-----------------------------------------------


                        ALIGN32

public decodehi2_
decodehi2_:             TEST_MMX                decodehi2mmx_
                        LOAD_WORDS_TO_DECODE    dh2nowork
                        CLEAR_EDGES             _oddhiscroll, _evenhiscroll
			DECIDE_ODDEVEN_EQUAL	dh2equal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP              _oddhiscroll, _linje
dh2oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		dh2oddloop

			; Decode even planes

                        SETUP_LOOP              _evenhiscroll, _linje
dh2evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco2
			OR_DECODED_DATA
			ITERATE_LOOP		dh2evenloop
			MODULO2
dh2nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

dh2equal:               SETUP_LOOP              _evenhiscroll, _linje
dh2equalloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl2pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		dh2equalloop
			MODULO2
			ret




;---------------------------------------------------
; Planar to chunky conversion, 2 bitplanes hires MMX
;---------------------------------------------------


                	ALIGN32

public decodehi2mmx_
decodehi2mmx_:		LOAD_WORDS_TO_DECODE	dh2mmxnowork
                        CLEAR_EDGES             _oddhiscroll, _evenhiscroll

                        DECIDE_ODDEVEN_EQUAL	dh2mmxequal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
dh2mmxoddloop:		LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dh2mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
dh2mmxevenloop:		LOAD_BITPLANE_WORD_MMX  ecx, _deco2
        		OR_DECODED_DATA_MMX
                        ITERATE_LOOP            dh2mmxevenloop
                        SAVE_BITPLANE_PTR       ecx, _bpl2pt
			MODULO2
dh2mmxnowork:		ret


        		ALIGN32

			; Decode odd and even planes, scroll equal

dh2mmxequal:            SETUP_LOOP_MMX          _evenhiscroll, _linje
        		LOAD_BITPLANE_PTR       ecx, _bpl1pt
        		LOAD_BITPLANE_PTR       edx, _bpl2pt
dh2mmxequalloop:	LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		OR_BITPLANE_WORD_MMX    edx, _deco2
        		STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dh2mmxequalloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl2pt
			MODULO2
			ret



;-----------------------------------------------
; Planar to chunky conversion, 3 bitplanes hires
;-----------------------------------------------


                        ALIGN32

public decodehi3_
decodehi3_:             TEST_MMX                decodehi3mmx_
                        LOAD_WORDS_TO_DECODE    dh3nowork
                        CLEAR_EDGES             _oddhiscroll, _evenhiscroll
			DECIDE_ODDEVEN_EQUAL	dh3equal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP              _oddhiscroll, _linje
dh3oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			STORE_DECODED_DATA
			ITERATE_LOOP		dh3oddloop

			; Decode even planes

                        SETUP_LOOP              _evenhiscroll, _linje
dh3evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco2
			OR_DECODED_DATA
			ITERATE_LOOP		dh3evenloop
			MODULO3
dh3nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

dh3equal:               SETUP_LOOP              _evenhiscroll, _linje
dh3equalloop:           LOAD_BITPLANE_WORD      _bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			STORE_DECODED_DATA
                        ITERATE_LOOP            dh3equalloop
                        MODULO3
			ret




;---------------------------------------------------
; Planar to chunky conversion, 3 bitplanes hires MMX
;---------------------------------------------------


                	ALIGN32

public decodehi3mmx_
decodehi3mmx_:          LOAD_WORDS_TO_DECODE    dh3mmxnowork
                        CLEAR_EDGES             _oddhiscroll, _evenhiscroll
                        DECIDE_ODDEVEN_EQUAL    dh3mmxequal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
dh3mmxoddloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco3
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dh3mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
dh3mmxevenloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco2
        		OR_DECODED_DATA_MMX
                        ITERATE_LOOP            dh3mmxevenloop
                        SAVE_BITPLANE_PTR       ecx, _bpl2pt
                        MODULO3
dh3mmxnowork:           ret


        		ALIGN32

			; Decode odd and even planes, scroll equal

dh3mmxequal:            SETUP_LOOP_MMX          _evenhiscroll, _linje
        		LOAD_BITPLANE_PTR       ecx, _bpl1pt
        		LOAD_BITPLANE_PTR       edx, _bpl2pt
                        LOAD_BITPLANE_PTR       edi, _bpl3pt
dh3mmxequalloop:        LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    edi, _deco3
        		STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dh3mmxequalloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl2pt
                        SAVE_BITPLANE_PTR       edi, _bpl3pt
                        MODULO3
			ret



;-----------------------------------------------
; Planar to chunky conversion, 4 bitplanes hires
;-----------------------------------------------


                        ALIGN32

public decodehi4_
decodehi4_:             TEST_MMX                decodehi4mmx_
                        LOAD_WORDS_TO_DECODE    dh4nowork
                        CLEAR_EDGES             _oddhiscroll, _evenhiscroll
			DECIDE_ODDEVEN_EQUAL	dh4equal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP              _oddhiscroll, _linje
dh4oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			STORE_DECODED_DATA
			ITERATE_LOOP		dh4oddloop

			; Decode even planes

                        SETUP_LOOP              _evenhiscroll, _linje
dh4evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl4pt, _deco4
			OR_DECODED_DATA
			ITERATE_LOOP		dh4evenloop
			MODULO4
dh4nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

dh4equal:               SETUP_LOOP              _evenhiscroll, _linje
dh4equalloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl2pt, _deco2
			OR_BITPLANE_WORD	_bpl3pt, _deco3
			OR_BITPLANE_WORD	_bpl4pt, _deco4
			STORE_DECODED_DATA
			ITERATE_LOOP		dh4equalloop
			MODULO4
			ret




;---------------------------------------------------
; Planar to chunky conversion, 4 bitplanes hires MMX
;---------------------------------------------------


                	ALIGN32

public decodehi4mmx_
decodehi4mmx_:          LOAD_WORDS_TO_DECODE    dh4mmxnowork
                        CLEAR_EDGES             _oddhiscroll, _evenhiscroll
                        DECIDE_ODDEVEN_EQUAL    dh4mmxequal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
dh4mmxoddloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco3
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dh4mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
                        LOAD_BITPLANE_PTR       edx, _bpl4pt
dh4mmxevenloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco2
                        OR_BITPLANE_WORD_MMX    edx, _deco4
                        OR_DECODED_DATA_MMX
                        ITERATE_LOOP            dh4mmxevenloop
                        SAVE_BITPLANE_PTR       ecx, _bpl2pt
                        SAVE_BITPLANE_PTR       edx, _bpl4pt
                        MODULO4
dh4mmxnowork:           ret


        		ALIGN32

			; Decode odd and even planes, scroll equal

dh4mmxequal:            SETUP_LOOP_MMX          _evenhiscroll, _linje
        		LOAD_BITPLANE_PTR       ecx, _bpl1pt
        		LOAD_BITPLANE_PTR       edx, _bpl2pt
                        LOAD_BITPLANE_PTR       edi, _bpl3pt
                        LOAD_BITPLANE_PTR       ebp, _bpl4pt
dh4mmxequalloop:        LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        		OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    edi, _deco3
                        OR_BITPLANE_WORD_MMX    ebp, _deco4
        		STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dh4mmxequalloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl2pt
                        SAVE_BITPLANE_PTR       edi, _bpl3pt
                        SAVE_BITPLANE_PTR       ebp, _bpl4pt
                        MODULO4
			ret



;----------------------------------------------------
; Planar to chunky conversion, 2 bitplanes dual lores
;----------------------------------------------------


                        ALIGN32

public decodedual2_
decodedual2_:		TEST_HIRES		decodedualhi2_
                        TEST_MMX                decodedual2mmx_
                        LOAD_WORDS_TO_DECODE	dd2nowork
                        CLEAR_EDGES_DUAL        _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
dd2oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		dd2oddloop

			; Decode even planes

			SETUP_LOOP		_evenscroll, _linje2
dd2evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		dd2evenloop
			MODULO2
dd2nowork:		ret




;--------------------------------------------------------
; Planar to chunky conversion, 2 bitplanes dual lores MMX
;--------------------------------------------------------


                	ALIGN32

public decodedual2mmx_
decodedual2mmx_:        LOAD_WORDS_TO_DECODE    dd2mmxnowork
                        CLEAR_EDGES_DUAL        _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
dd2mmxoddloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd2mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje2
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
dd2mmxevenloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd2mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        MODULO2
dd2mmxnowork:           ret




;----------------------------------------------------
; Planar to chunky conversion, 3 bitplanes dual lores
;----------------------------------------------------


                        ALIGN32

public decodedual3_
decodedual3_:		TEST_HIRES		decodedualhi3_
                        TEST_MMX                decodedual3mmx_
                        LOAD_WORDS_TO_DECODE	dd3nowork
                        CLEAR_EDGES_DUAL        _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
dd3oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		dd3oddloop

			; Decode even planes

			SETUP_LOOP		_evenscroll, _linje2
dd3evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		dd3evenloop
			MODULO3
dd3nowork:		ret




;--------------------------------------------------------
; Planar to chunky conversion, 3 bitplanes dual lores MMX
;--------------------------------------------------------


                	ALIGN32

public decodedual3mmx_
decodedual3mmx_:        LOAD_WORDS_TO_DECODE    dd3mmxnowork
                        CLEAR_EDGES_DUAL       _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
dd3mmxoddloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd3mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje2
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
dd3mmxevenloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd3mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        MODULO3
dd3mmxnowork:           ret




;----------------------------------------------------
; Planar to chunky conversion, 4 bitplanes dual lores
;----------------------------------------------------


                        ALIGN32

public decodedual4_
decodedual4_:		TEST_HIRES		decodedualhi4_
                        TEST_MMX                decodedual4mmx_
                        LOAD_WORDS_TO_DECODE    dd4nowork
                        CLEAR_EDGES_DUAL       _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
dd4oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		dd4oddloop

			; Decode even planes

			SETUP_LOOP		_evenscroll, _linje2
dd4evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco1
			OR_BITPLANE_WORD	_bpl4pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		dd4evenloop
			MODULO4
dd4nowork:		ret




;--------------------------------------------------------
; Planar to chunky conversion, 4 bitplanes dual lores MMX
;--------------------------------------------------------


                	ALIGN32

public decodedual4mmx_
decodedual4mmx_:        LOAD_WORDS_TO_DECODE    dd4mmxnowork
                        CLEAR_EDGES_DUAL       _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
dd4mmxoddloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd4mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje2
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
                        LOAD_BITPLANE_PTR       edx, _bpl4pt
dd4mmxevenloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd4mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        SAVE_BITPLANE_PTR       edx,_bpl4pt
                        MODULO4
dd4mmxnowork:           ret




;----------------------------------------------------
; Planar to chunky conversion, 5 bitplanes dual lores
;----------------------------------------------------


                        ALIGN32

public decodedual5_
decodedual5_:           TEST_MMX                decodedual5mmx_
                        LOAD_WORDS_TO_DECODE    dd5nowork
                        CLEAR_EDGES_DUAL       _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
dd5oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco2
			OR_BITPLANE_WORD	_bpl5pt, _deco3
			STORE_DECODED_DATA
			ITERATE_LOOP		dd5oddloop

			; Decode even planes

			SETUP_LOOP		_evenscroll, _linje2
dd5evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco1
			OR_BITPLANE_WORD	_bpl4pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		dd5evenloop
			MODULO5
dd5nowork:		ret




;--------------------------------------------------------
; Planar to chunky conversion, 5 bitplanes dual lores MMX
;--------------------------------------------------------


                	ALIGN32

public decodedual5mmx_
decodedual5mmx_:        LOAD_WORDS_TO_DECODE    dd5mmxnowork
                        CLEAR_EDGES_DUAL       _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
                        LOAD_BITPLANE_PTR       ebp, _bpl5pt
dd5mmxoddloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    ebp, _deco3
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd5mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt
                        SAVE_BITPLANE_PTR       ebp, _bpl5pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje2
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
                        LOAD_BITPLANE_PTR       edx, _bpl4pt
dd5mmxevenloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd5mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        SAVE_BITPLANE_PTR       edx,_bpl4pt
                        MODULO5
dd5mmxnowork:           ret



;----------------------------------------------------
; Planar to chunky conversion, 6 bitplanes dual lores
;----------------------------------------------------


                        ALIGN32

public decodedual6_
decodedual6_:           TEST_MMX                decodedual6mmx_
                        LOAD_WORDS_TO_DECODE    dd6nowork
                        CLEAR_EDGES_DUAL        _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP              _oddscroll, _linje
dd6oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco2
			OR_BITPLANE_WORD	_bpl5pt, _deco3
			STORE_DECODED_DATA
			ITERATE_LOOP		dd6oddloop

			; Decode even planes

			SETUP_LOOP		_evenscroll, _linje2
dd6evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco1
			OR_BITPLANE_WORD	_bpl4pt, _deco2
			OR_BITPLANE_WORD	_bpl6pt, _deco3
			STORE_DECODED_DATA
			ITERATE_LOOP		dd6evenloop
			MODULO6
dd6nowork:		ret




;--------------------------------------------------------
; Planar to chunky conversion, 6 bitplanes dual lores MMX
;--------------------------------------------------------


                	ALIGN32

public decodedual6mmx_
decodedual6mmx_:        LOAD_WORDS_TO_DECODE    dd6mmxnowork
                        CLEAR_EDGES_DUAL       _oddscroll, _evenscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
                        LOAD_BITPLANE_PTR       ebp, _bpl5pt
dd6mmxoddloop:          LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    ebp, _deco3
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd6mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt
                        SAVE_BITPLANE_PTR       ebp, _bpl5pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenscroll, _linje2
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
                        LOAD_BITPLANE_PTR       edx, _bpl4pt
                        LOAD_BITPLANE_PTR       edi, _bpl6pt
dd6mmxevenloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        OR_BITPLANE_WORD_MMX    edi, _deco3
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            dd6mmxevenloop
                        SAVE_BITPLANE_PTR       ecx,_bpl2pt
                        SAVE_BITPLANE_PTR       edx,_bpl4pt
                        SAVE_BITPLANE_PTR       edi,_bpl6pt
                        MODULO6
dd6mmxnowork:           ret



;----------------------------------------------------
; Planar to chunky conversion, 2 bitplanes dual hires
;----------------------------------------------------


                        ALIGN32

public decodedualhi2_
decodedualhi2_:         TEST_MMX                decodedualhi2mmx_
                        LOAD_WORDS_TO_DECODE    ddh2nowork
                        CLEAR_EDGES_DUAL        _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP              _oddhiscroll, _linje
ddh2oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		ddh2oddloop

			; Decode even planes

			SETUP_LOOP		_evenhiscroll, _linje2
ddh2evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		ddh2evenloop
			MODULO2
ddh2nowork:		ret




;--------------------------------------------------------
; Planar to chunky conversion, 2 bitplanes dual hires MMX
;--------------------------------------------------------


                	ALIGN32

public decodedualhi2mmx_
decodedualhi2mmx_:      LOAD_WORDS_TO_DECODE    ddh2mmxnowork
                        CLEAR_EDGES_DUAL        _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
ddh2mmxoddloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            ddh2mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenhiscroll, _linje2
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
ddh2mmxevenloop:        LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            ddh2mmxevenloop
                        SAVE_BITPLANE_PTR       ecx, _bpl2pt
                        MODULO2
ddh2mmxnowork:          ret





;----------------------------------------------------
; Planar to chunky conversion, 3 bitplanes dual hires
;----------------------------------------------------


                        ALIGN32

public decodedualhi3_
decodedualhi3_:         TEST_MMX                decodedualhi3mmx_
                        LOAD_WORDS_TO_DECODE    ddh3nowork
                        CLEAR_EDGES_DUAL        _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP              _oddhiscroll, _linje
ddh3oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		ddh3oddloop

			; Decode even planes

			SETUP_LOOP		_evenhiscroll, _linje2
ddh3evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco1
			STORE_DECODED_DATA
			ITERATE_LOOP		ddh3evenloop
			MODULO3
ddh3nowork:		ret



;--------------------------------------------------------
; Planar to chunky conversion, 3 bitplanes dual hires MMX
;--------------------------------------------------------


                	ALIGN32

public decodedualhi3mmx_
decodedualhi3mmx_:      LOAD_WORDS_TO_DECODE    ddh3mmxnowork
                        CLEAR_EDGES_DUAL        _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
ddh3mmxoddloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            ddh3mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenhiscroll, _linje2
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
ddh3mmxevenloop:        LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            ddh3mmxevenloop
                        SAVE_BITPLANE_PTR       ecx, _bpl2pt
                        MODULO3
ddh3mmxnowork:          ret





;----------------------------------------------------
; Planar to chunky conversion, 4 bitplanes dual hires
;----------------------------------------------------


                        ALIGN32

public decodedualhi4_
decodedualhi4_:         TEST_MMX                decodedualhi4mmx_
                        LOAD_WORDS_TO_DECODE    ddh4nowork
                        CLEAR_EDGES_DUAL        _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP              _oddhiscroll, _linje
ddh4oddloop:		LOAD_BITPLANE_WORD	_bpl1pt, _deco1
			OR_BITPLANE_WORD	_bpl3pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		ddh4oddloop

			; Decode even planes

			SETUP_LOOP		_evenhiscroll, _linje2
ddh4evenloop:		LOAD_BITPLANE_WORD	_bpl2pt, _deco1
			OR_BITPLANE_WORD	_bpl4pt, _deco2
			STORE_DECODED_DATA
			ITERATE_LOOP		ddh4evenloop
			MODULO4
ddh4nowork:		ret




;--------------------------------------------------------
; Planar to chunky conversion, 4 bitplanes dual hires MMX
;--------------------------------------------------------


                	ALIGN32

public decodedualhi4mmx_
decodedualhi4mmx_:      LOAD_WORDS_TO_DECODE    ddh4mmxnowork
                        CLEAR_EDGES_DUAL        _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_MMX          _oddhiscroll, _linje
                        LOAD_BITPLANE_PTR       ecx, _bpl1pt
                        LOAD_BITPLANE_PTR       edx, _bpl3pt
ddh4mmxoddloop:         LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            ddh4mmxoddloop
                        SAVE_BITPLANE_PTR       ecx, _bpl1pt
                        SAVE_BITPLANE_PTR       edx, _bpl3pt

			; Decode even planes

                        SETUP_LOOP_MMX          _evenhiscroll, _linje2
                        LOAD_BITPLANE_PTR       ecx, _bpl2pt
                        LOAD_BITPLANE_PTR       edx, _bpl4pt
ddh4mmxevenloop:        LOAD_BITPLANE_WORD_MMX  ecx, _deco1
                        OR_BITPLANE_WORD_MMX    edx, _deco2
                        STORE_DECODED_DATA_MMX
                        ITERATE_LOOP            ddh4mmxevenloop
                        SAVE_BITPLANE_PTR       ecx, _bpl2pt
                        SAVE_BITPLANE_PTR       edx, _bpl4pt
                        MODULO4
ddh4mmxnowork:          ret




;------------------------------------------------------------
; Planar to chunky conversion, 1 bitplane hires for lores VGA
;------------------------------------------------------------


                        ALIGN32

public decode320hi1_
decode320hi1_:          LOAD_WORDS_TO_DECODE    d320h1nowork

			; Decode odd planes

                        SETUP_LOOP_320          _oddhiscroll, _linje
d320h1oddloop:		LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			STORE_DECODED_DATA_320
			ITERATE_LOOP		d320h1oddloop
			MODULO1
d320h1nowork:		ret


;-------------------------------------------------------------
; Planar to chunky conversion, 2 bitplanes hires for lores VGA
;-------------------------------------------------------------


                        ALIGN32

public decode320hi2_
decode320hi2_:          LOAD_WORDS_TO_DECODE    d320h2nowork
			DECIDE_ODDEVEN_EQUAL	d320h2equal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_320          _oddhiscroll, _linje
d320h2oddloop:		LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			STORE_DECODED_DATA_320
			ITERATE_LOOP		d320h2oddloop

			; Decode even planes

                        SETUP_LOOP_320          _evenhiscroll, _linje
d320h2evenloop:		LOAD_BITPLANE_WORD_320	_bpl2pt, _deco320hi2
			OR_DECODED_DATA_320
			ITERATE_LOOP		d320h2evenloop
			MODULO2
d320h2nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

d320h2equal:            SETUP_LOOP_320          _evenhiscroll, _linje
d320h2equalloop:	LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			OR_BITPLANE_WORD_320	_bpl2pt, _deco320hi2
			STORE_DECODED_DATA_320
			ITERATE_LOOP		d320h2equalloop
			MODULO2
			ret


;-------------------------------------------------------------
; Planar to chunky conversion, 3 bitplanes hires for lores VGA
;-------------------------------------------------------------


                        ALIGN32

public decode320hi3_
decode320hi3_:          LOAD_WORDS_TO_DECODE    d320h3nowork
			DECIDE_ODDEVEN_EQUAL	d320h3equal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_320          _oddhiscroll, _linje
d320h3oddloop:		LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			OR_BITPLANE_WORD_320	_bpl3pt, _deco320hi3
			STORE_DECODED_DATA_320
			ITERATE_LOOP		d320h3oddloop

			; Decode even planes

                        SETUP_LOOP_320          _evenhiscroll, _linje
d320h3evenloop:		LOAD_BITPLANE_WORD_320	_bpl2pt, _deco320hi2
			OR_DECODED_DATA_320
			ITERATE_LOOP		d320h3evenloop
			MODULO3
d320h3nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

d320h3equal:            SETUP_LOOP_320          _evenhiscroll, _linje
d320h3equalloop:	LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			OR_BITPLANE_WORD_320	_bpl2pt, _deco320hi2
			OR_BITPLANE_WORD_320	_bpl3pt, _deco320hi3
			STORE_DECODED_DATA_320
			ITERATE_LOOP		d320h3equalloop
			MODULO3
			ret


;-------------------------------------------------------------
; Planar to chunky conversion, 4 bitplanes hires for lores VGA
;-------------------------------------------------------------


                        ALIGN32

public decode320hi4_
decode320hi4_:          LOAD_WORDS_TO_DECODE    d320h4nowork
			DECIDE_ODDEVEN_EQUAL	d320h4equal, _oddhiscroll, _evenhiscroll

			; Decode odd planes

                        SETUP_LOOP_320          _oddhiscroll, _linje
d320h4oddloop:		LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			OR_BITPLANE_WORD_320	_bpl3pt, _deco320hi3
			STORE_DECODED_DATA_320
			ITERATE_LOOP		d320h4oddloop

			; Decode even planes

                        SETUP_LOOP_320          _evenhiscroll, _linje
d320h4evenloop:		LOAD_BITPLANE_WORD_320	_bpl2pt, _deco320hi2
			OR_BITPLANE_WORD_320	_bpl4pt, _deco320hi4
			OR_DECODED_DATA_320
			ITERATE_LOOP		d320h4evenloop
			MODULO4
d320h4nowork:		ret


                        ALIGN32

			; Decode odd and even planes, scroll equal

d320h4equal:            SETUP_LOOP_320          _evenhiscroll, _linje
d320h4equalloop:	LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			OR_BITPLANE_WORD_320	_bpl2pt, _deco320hi2
			OR_BITPLANE_WORD_320	_bpl3pt, _deco320hi3
			OR_BITPLANE_WORD_320	_bpl4pt, _deco320hi4
                        STORE_DECODED_DATA_320
			ITERATE_LOOP		d320h4equalloop
			MODULO4
			ret


;------------------------------------------------------------------
; Planar to chunky conversion, 2 bitplanes dual hires for lores VGA
;------------------------------------------------------------------


                        ALIGN32

public decodedual320hi2_
decodedual320hi2_:	LOAD_WORDS_TO_DECODE	dd320h2nowork

			; Decode odd planes

                        SETUP_LOOP_320          _oddhiscroll, _linje
dd320h2oddloop:		LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			STORE_DECODED_DATA_320
			ITERATE_LOOP		dd320h2oddloop

			; Decode even planes

                        SETUP_LOOP_320          _evenhiscroll, _linje2
dd320h2evenloop:	LOAD_BITPLANE_WORD_320	_bpl2pt, _deco320hi1
			STORE_DECODED_DATA_320
			ITERATE_LOOP		dd320h2evenloop
			MODULO2
dd320h2nowork:		ret


;------------------------------------------------------------------
; Planar to chunky conversion, 3 bitplanes dual hires for lores VGA
;------------------------------------------------------------------


                        ALIGN32

public decodedual320hi3_
decodedual320hi3_:	LOAD_WORDS_TO_DECODE	dd320h3nowork

			; Decode odd planes

                        SETUP_LOOP_320          _oddhiscroll, _linje
dd320h3oddloop:		LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			OR_BITPLANE_WORD_320	_bpl3pt, _deco320hi2
			STORE_DECODED_DATA_320
                        ITERATE_LOOP            dd320h3oddloop

			; Decode even planes

                        SETUP_LOOP_320          _evenhiscroll, _linje2
dd320h3evenloop:	LOAD_BITPLANE_WORD_320	_bpl2pt, _deco320hi1
			STORE_DECODED_DATA_320
			ITERATE_LOOP		dd320h3evenloop
			MODULO3
dd320h3nowork:		ret


;------------------------------------------------------------------
; Planar to chunky conversion, 4 bitplanes dual hires for lores VGA
;------------------------------------------------------------------


                        ALIGN32

public decodedual320hi4_
decodedual320hi4_:	LOAD_WORDS_TO_DECODE	dd320h4nowork

			; Decode odd planes

                        SETUP_LOOP_320          _oddhiscroll, _linje
dd320h4oddloop:		LOAD_BITPLANE_WORD_320	_bpl1pt, _deco320hi1
			OR_BITPLANE_WORD_320	_bpl3pt, _deco320hi2
			STORE_DECODED_DATA_320
			ITERATE_LOOP		dd320h4oddloop

			; Decode even planes

                        SETUP_LOOP_320          _evenhiscroll, _linje2
dd320h4evenloop:	LOAD_BITPLANE_WORD_320	_bpl2pt, _deco320hi1
			OR_BITPLANE_WORD_320	_bpl4pt, _deco320hi2
			STORE_DECODED_DATA_320
			ITERATE_LOOP		dd320h4evenloop
			MODULO4
dd320h4nowork:		ret

#endif



#ifndef GRAPHEM_C

; COLOR - $dff180 to $dff1be


                ALIGN32

public wcolor_
wcolor_:        and     edx,0fffh
                push    edx
                mov     edx,dword ptr [_colortab+edx*4] ; Translate color
                mov     dword ptr [_shadcol-0300h+ecx*2],edx
                pop     edx
                and     edx,0eeeh
                shr     edx,1
                mov     edx,dword ptr [_colortab+edx*4] ; Translate color
                mov     dword ptr [_shadcol-0300h+128+ecx*2],edx
                ret


                ALIGN32

public wcolorCC_
wcolorCC_:      push    eax
                mov     eax,dword ptr [_ypos]
                cmp     eax,dword ptr [_cliptop]
                jae     wcolorCC1
                pop     eax
                jmp     wcolor_
wcolorCC1:      cmp     eax,dword ptr [_clipbot]
                jb      wcolorCC2
                pop     eax
                jmp     wcolor_
wcolorCC2:      mov     eax,dword ptr [_xpos]
                test    byte ptr [_cop_running_beyond_line],1
                jz      wcolorCCncrbl
                add     eax,CYCLESPERLINE
wcolorCCncrbl:  shl     eax,1
                cmp     eax,dword ptr [_clipleftx]                     
                jae     wcolorCC3
                pop     eax
                jmp     wcolor_
wcolorCC3:      push    ebx
                mov     ebx,dword ptr [_delay_color_total]
                mov     word ptr [_delay_color + 8*ebx], ax
                mov     word ptr [_delay_color + 2 + 8*ebx],cx
                mov     word ptr [_delay_color + 4 + 8*ebx],dx
                inc     dword ptr [_delay_color_total]
                pop     ebx
                pop     eax
                ret

#endif

_TEXT ends

_DATA segment para public 'DATA'

include data\memory.inc
include data\inout.inc
include data\fellow.inc
include data\graphem.inc
include data\copper.inc
include data\draw.inc
	
; Declare these here to make sure they are aligned on 32-byte boundrary
; Can't make C do that for some reason

public _deco1,_deco2,_deco3,_deco4,_deco5,_deco6

                align 16
_deco1:         dd      512 dup (0)
_deco2:         dd      512 dup (0)
_deco3:         dd      512 dup (0)
_deco4:         dd      512 dup (0)
_deco5:         dd      512 dup (0)
_deco6:         dd      512 dup (0)


_sprite4_0:	dd	offset _decosc01 
		dd	offset _decosc11
		dd	offset _decosc21
		dd	offset _decosc31
_sprite4_1:	dd	offset _decosc02 
		dd	offset _decosc12
		dd	offset _decosc22
		dd	offset _decosc32


_DATA ends

_BSS segment dword public 'DATA'
_BSS ends

end
